//----------------------------------------------------------------------------
// C main line
//----------------------------------------------------------------------------
#include "header.h"
#define SetNL_RST_Data   P0DATA|=NL_RST_MASK
#define ClearNL_RST_Data   P0DATA&=~NL_RST_MASK

#define SetNL_nSS_Data   P1DATA|=NL_nSS_MASK
#define ClearNL_nSS_Data   P1DATA&=~NL_nSS_MASK




 extern uint8 RF_freq;
UINT8  rx_packet_length,*rx_packet_header;
uint8 receive_prepare_sleep_flag,respond_sleep_flag; 
 static U8 Hopping_freqIndex=0;
const U8 RF_cyrf8935_CH0[]=
{
	0,40,
	4,44,
	
	8,48,
	12,52,
	
	16,56,
	20,60,
	
	24,64,
	28,68,
	
	32,72,
	36,76
};

const U8 RF_cyrf8935_CH1[]=
{
	1,41,
	5,45,
	
	9,49,
	13,53,
	
	17,57,
	21,61,
	
	25,65,
	29,69,
	
	33,73,
	37,77
};

const U8 RF_cyrf8935_CH2[]=
{
	2,42,
	6,46,
	
	10,50,
	14,54,
	
	18,58,
	22,62,
	
	26,66,
	30,70,
	
	34,74,
	38,78
};

const U8 RF_cyrf8935_CH3[]=
{
	3,43,
	7,47,
	
	11,51,
	15,55,
	
	19,59,
	23,63,
	
	27,67,
	31,71,
	
	35,75,
	39,79
};
 void Change_Channel(void)
{
	
	if(++Hopping_freqIndex>=20)Hopping_freqIndex = 0;
	RF_freq=RF_cyrf8935_CH2[Hopping_freqIndex];
}

void spi_init(void)
{
   SetNL_nSS_Data;
   SPIM_Start();	
}

UINT8 spi_rw(UINT8 i)
{
   		M8C_ClearWDT;
	   	INT_CLR0 &=~(INT_MSK0_SPI_RX|INT_MSK0_SPI_TX);
		SPIDATA=i;
		while(!(INT_CLR0&INT_MSK0_SPI_RX));
		i=SPIDATA;
		M8C_ClearWDT;
		return(i);		
}
void writebyte_cyrf8935(unsigned char wbyte)
{
	(void)spi_rw(wbyte);
}

U8 readbyte_cyrf8935(void)
{
	U8 value;
	value=spi_rw(0XFF);
	return(value);			
}
uint16 read_cyrf8935_reg(unsigned char address)
{
	uint16 value;
	uint8 value_l,value_h;
	value=0;
	value_h=0;
	value_l=0;
	ClearNL_nSS_Data;
   
	writebyte_cyrf8935(address | 0x80);
	value_h=readbyte_cyrf8935();
	value_l=readbyte_cyrf8935();
	value=value_h<<8;
	value+=value_l;
	SetNL_nSS_Data;		
	return(value);	
}
void write_cyrf8935_reg(U8 address,U8 value_h,U8 value_l)
{
   
	ClearNL_nSS_Data;
	
	writebyte_cyrf8935(address);
	writebyte_cyrf8935(value_h);
	writebyte_cyrf8935(value_l);
	
	SetNL_nSS_Data;		
} 
void Enter_Idle_State(void)
{
	write_cyrf8935_reg(7,0,RF_freq);
}
void init_cyrf8935(void)
{
	uint16 tmp;
	ClearNL_RST_Data;
	
	Delay100us(30);
	SetNL_RST_Data;
	Delay100us(20);
	SPIM_DisableInt();
	
while(1)
{
	M8C_ClearWDTAndSleep;
	//init fram_tab
	write_cyrf8935_reg(32,0x18,0x20);
	write_cyrf8935_reg(33,0x32,0xbf);
	write_cyrf8935_reg(34,0x10,0x00);
	write_cyrf8935_reg(35,0x05,0x01);
	write_cyrf8935_reg(36,0x34,0x56);
	write_cyrf8935_reg(37,0x56,0x78);
	write_cyrf8935_reg(38,0x78,0xab);
	write_cyrf8935_reg(39,0x9a,0xcd);
    write_cyrf8935_reg(40,0x20,0x47);
    write_cyrf8935_reg(41,0xf0,0x00);
	write_cyrf8935_reg(42,0xfd,0xff);
	write_cyrf8935_reg(43,0x00,0x0f);
	
	Delay100us(20);
	tmp=read_cyrf8935_reg(48);
	if((tmp&0x0f00) == 0x0100)
	{
		break;
	}
}
	//init rf_tab 
	write_cyrf8935_reg(0,0x6f,0xe1);
	write_cyrf8935_reg(1,0x56,0x81);
	write_cyrf8935_reg(2,0x66,0x17);
	write_cyrf8935_reg(4,0x9c,0xc9);
	write_cyrf8935_reg(5,0x66,0x37);
	write_cyrf8935_reg(8,0x6c,0x90);
	write_cyrf8935_reg(9,0x19,0x20);
	write_cyrf8935_reg(10,0x7f,0xfd);
	write_cyrf8935_reg(11,0x00,0x08);
	write_cyrf8935_reg(12,0x00,0x00);
	write_cyrf8935_reg(13,0x48,0xbd);
	write_cyrf8935_reg(22,0x00,0xff);
	write_cyrf8935_reg(23,0x00,0x05);
	write_cyrf8935_reg(24,0x00,0x67);
	write_cyrf8935_reg(25,0x16,0x59);
	write_cyrf8935_reg(26,0x19,0xe0);
	write_cyrf8935_reg(27,0x12,0x00);
	write_cyrf8935_reg(28,0x18,0x00);
	
	Enter_Idle_State();	
	
}
void read_FIFO(void)
{
	U8 i;
	ClearNL_nSS_Data;
						
	writebyte_cyrf8935(0xB2);
	
	
	rx_packet_length=readbyte_cyrf8935();
	if(rx_packet_length==BIND_PACKET_LEN)
		{
			rx_packet_header=&rx_bind_packet.device_act_command;
			rx_bind_packet.length=rx_packet_length;
		}
	else if (rx_packet_length==PING_PACKET_LEN)
		{
			rx_packet_header=&rx_ping_packet.device_act_command;
			rx_ping_packet.length=rx_packet_length;
		}
	else 
		{
			rx_packet_header=&rx_connect_packet.device_act_command;
			rx_connect_packet.length=rx_packet_length;
		}

    	for(i=0;i<rx_packet_length;i++)
    		{
			*rx_packet_header= readbyte_cyrf8935();
			rx_packet_header++;
    		}

	SetNL_nSS_Data;
}

void write_FIFO(uint8 packet_length,uint8 *packet_header)
{
	
	U8 i;
	ClearNL_nSS_Data;		
	writebyte_cyrf8935(0x32);			
	for(i=0;i<packet_length+1;i++)
	{
		writebyte_cyrf8935(*packet_header);
		packet_header++;
	}				
	SetNL_nSS_Data;			
}
void Reset_Tx_Fifo(void)
{
	write_cyrf8935_reg(0x34,0x80,0x00);
}
void Reset_Rx_Fifo(void)
{
	write_cyrf8935_reg(0x34,0x00,0x80);
}



