#include "header.h" 
 uint8 usb_in_data[5];
 extern  U8 Sgn6210_dataH, Sgn6210_dataL;
extern  U8 receive_success_flag;
extern  U8  RF_freq;
extern   UINT8  rx_packet_length,*rx_packet_header;

CONNECT_PACKET 		tx_connect_packet,rx_connect_packet;
 BIND_PACKET			tx_bind_packet,rx_bind_packet;
PING_PACKET			tx_ping_packet,rx_ping_packet;

void ReadBindParameters(void)
{
	/* Read the Serial Number back into a RAM buffer */
       E2PROMx128_1_E2Read(0, (UINT8*)&rx_bind_packet, BIND_PACKET_LEN+1);
}
void SaveBindParameters(void)
{
	E2PROMx128_1_bE2Write(0, (UINT8*)&tx_bind_packet, BIND_PACKET_LEN+1, 25);
}
void RF_Transfer (void)
{
	uint16 tmp,TX_TimeOut,RX_TimeOut;
	uint8 i;
   //Change_Channel();
	Reset_Rx_Fifo();
	write_cyrf8935_reg(0x07,0x00,0x80 | RF_freq);
	TimerDelay10usec();
	
	RX_TimeOut = 150;
	while(1)
	{
		M8C_ClearWDTAndSleep;
		tmp=read_cyrf8935_reg(48);
		if(tmp&0x0040) 
		{
			break;
		}	
	}
	
	//check data start	
	//first step   check   crc
	tmp=read_cyrf8935_reg(48);
	if((tmp & 0x8000)!=0)
	{
		Enter_Idle_State();
		return;
	}
	else
	{
		read_FIFO();
		//second  step	check  receive data 
		if(rx_packet_length==BIND_PACKET_LEN)
			{
				TxBindData();
			}
		else if(rx_packet_length==CONNECT_PACKET_LEN)
			{
				TxConnectData();
			}
		else if(rx_packet_length==PING_PACKET_LEN)
			{
				TxPingData();
			}
		else
			{
				Enter_Idle_State();
				return;
			}
		
	} 
	
	
	
	
	usb_in_data[0]=rx_connect_packet.device_type;
	usb_in_data[1]=rx_connect_packet.buttons;
	usb_in_data[2]=rx_connect_packet.optical_x;
	usb_in_data[3]=rx_connect_packet.optical_y;
	usb_in_data[4]=rx_connect_packet.wheel;
	
	  while(USB_bGetEPState(1)==IN_BUFFER_FULL);  //Wait for ACK before loading data  
	  //ACK has occurred, load the endpoint and toggle the data bit  
	  USB_LoadEP(1, usb_in_data, 5);  
		 
}
void TxConnectData(void)
{
	uint16 tmp;
	Reset_Tx_Fifo();
	write_FIFO(CONNECT_PACKET_LEN,&rx_connect_packet.length);
	write_cyrf8935_reg(0x07,0x01,RF_freq);

	TimerDelay10usec();
	
	while(1)
	{
		M8C_ClearWDTAndSleep;
		tmp=read_cyrf8935_reg(48);
		if(tmp&0x0040) 
		{
			break;
		}
		
	}
}
void TxBindData(void)
{
	uint16 tmp;
	Reset_Tx_Fifo();
	write_FIFO(BIND_PACKET_LEN,&rx_bind_packet.length);
	write_cyrf8935_reg(0x07,0x01,RF_freq);

	TimerDelay10usec();
	
	while(1)
	{
		M8C_ClearWDTAndSleep;
		tmp=read_cyrf8935_reg(48);
		if(tmp&0x0040) 
		{
			break;
		}
		
	}
}
void TxPingData(void)
{
	uint16 tmp;
	Reset_Tx_Fifo();
	write_FIFO(PING_PACKET_LEN,&rx_ping_packet.length);
	write_cyrf8935_reg(0x07,0x01,RF_freq);

	TimerDelay10usec();
	
	while(1)
	{
		M8C_ClearWDTAndSleep;
		tmp=read_cyrf8935_reg(48);
		if(tmp&0x0040) 
		{
			break;
		}
		
	}
}
