
#ifndef _PROTOCOL_H_
#define _PROTOCOL_H_

typedef  struct  
{
	uint8 	length;
	uint8	device_act_command;
	uint8	mid_1;          // Manufacturing id of bound bridge
       	uint8 	mid_2;
       	uint8 	mid_3;
       	uint8 	mid_4;
	uint8	device_type;
	uint8	buttons;
	uint8  	optical_x;
	uint8  	optical_y;
	uint8  	wheel;
	uint8	RF_freq;
	uint8	sleep_flag;
	
	uint8	buf1;
	uint8 	buf2;
	uint8	buf3;
	

}CONNECT_PACKET;
#define 	CONNECT_PACKET_LEN		sizeof(CONNECT_PACKET)-1


typedef struct 
{
	uint8 	length;
	uint8	device_act_command;
	uint8	mid_1;          // Manufacturing id of bound bridge
       	uint8 	mid_2;
       	uint8 	mid_3;
       	uint8 	mid_4;
}BIND_PACKET;
#define BIND_PACKET_LEN            sizeof(BIND_PACKET)-1

typedef struct 
{
	uint8      length;
	uint8 	device_act_command;
	uint8	mid_1;          // Manufacturing id of bound bridge
       	uint8 	mid_2;
       	uint8 	mid_3;
       	uint8 	mid_4;
	uint8	RF_freq;
}PING_PACKET;
#define	PING_PACKET_LEN	sizeof(PING_PACKET)-1





extern 	CONNECT_PACKET 		tx_connect_packet,rx_connect_packet;
extern  	BIND_PACKET			tx_bind_packet,rx_bind_packet;
extern	PING_PACKET			tx_ping_packet,rx_ping_packet;



#define 	ping_command       			0x11;
#define	bind_command			0x90;
#define	connect_command			0x33;


void TxConnectData(void);
void TxBindData(void);
void TxPingData(void);
void ReadBindParameters(void);
void SaveBindParameters(void);
void RF_Transfer (void);
#endif
