;--------------------------------------------------------------------------
;
;  Filename:    timer_a.asm
;
;  Description: Looping delays
;
;--------------------------------------------------------------------------
;
; Copyright 2005-2006, Cypress Semiconductor Corporation.
;
; This software is owned by Cypress Semiconductor Corporation (Cypress)
; and is protected by and subject to worldwide patent protection (United
; States and foreign), United States copyright laws and international
; treaty provisions. Cypress hereby grants to licensee a personal,
; non-exclusive, non-transferable license to copy, use, modify, create
; derivative works of, and compile the Cypress Source Code and derivative
; works for the sole purpose of creating custom software in support of
; licensee product to be used only in conjunction with a Cypress integrated
; circuit as specified in the applicable agreement. Any reproduction,
; modification, translation, compilation, or representation of this
; software except as specified above is prohibited without the express
; written permission of Cypress.
;
; Disclaimer: CYPRESS MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
; WITH REGARD TO THIS MATERIAL, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
; WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
; Cypress reserves the right to make changes without further notice to the
; materials described herein. Cypress does not assume any liability arising
; out of the application or use of any product or circuit described herein.
; Cypress does not authorize its products for use as critical components in
; life-support systems where a malfunction or failure may reasonably be
; expected to result in significant injury to the user. The inclusion of
; Cypress' product in a life-support systems application implies that the
; manufacturer assumes all risk of such use and in doing so indemnifies
; Cypress against all charges.
;
; Use may be limited by and subject to the applicable Cypress software
; license agreement.
;
;--------------------------------------------------------------------------

;--------------------------------------------------------------------------;
;                                                                          ;
;                      I N C L U D E   F I L E S                           ;
;                                                                          ;
;--------------------------------------------------------------------------;

        INCLUDE "M8C.inc"
export _TimerDelay10usec
export _TimerDelay50usec
export _TimerDelay100usec
        Suspend_CodeCompressor  ; Code breaks if "subroutinized".
.section

//--------------------------------------------------------------------------
// TimerDelay10usec
//--------------------------------------------------------------------------
_TimerDelay10usec::
     M8C_ClearWDTAndSleep;                                       ; [13] cycles for lcall
    MOV     A, 4                            ; [4]  cycles
    JMP     DelayUsecLoop                   ; [5]  cycles

//--------------------------------------------------------------------------
// TimerDelay50usec
//--------------------------------------------------------------------------
_TimerDelay50usec::
    M8C_ClearWDTAndSleep;                                        ; [13] cycles for lcall
    MOV     A, 28                           ; [4]  cycles
    JMP     DelayUsecLoop                   ; [5]  cycles

//--------------------------------------------------------------------------
// TimerDelay100usec
//--------------------------------------------------------------------------
_TimerDelay100usec::
    M8C_ClearWDTAndSleep;                                        ; [13] cycles for lcall
    MOV     A, 58                           ; [4]  cycles
    jmp     DelayUsecLoop                   ; [5]  cycles

;--------------------------------------------------------------------------
; DelayUsecLoop
;--------------------------------------------------------------------------
DelayUsecLoop::

    AND     A, FFh                          ; [4] cycles
    LJMP    fwd                             ; [7] cycles
fwd:                                        ;
    DEC     A                               ; [4] cycles
    JNZ     DelayUsecLoop                   ; [5] cycles
    CMP     A, 0                            ; [5] cycles
    CMP     A, 0                            ; [5] cycles
    RET                                     ; [8] cycles for return
.endsection

        Resume_CodeCompressor
; #############################################################################

